/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is autoprint.
 *
 * The Initial Developer of the Original Code is
 * Daniel Luttinger.
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *		Daniel Luttinger <daniel@luttinger.eu>
 *		Frank Nagel <f.nagel@fkn-systems.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

(function() {
	
	// global scope variables and shorthand
	this.autoprint2FilterEditorExt = {};
	var ap2FEE = this.autoprint2FilterEditorExt;
	var self = ap2FEE;
	
	ap2FEE.oldOnload=window.onload;  // evil hack
	
	// some debug info and log shorthand
	ap2FEE.debug = true;	
	ap2FEE.version = "($VER: filterEditorOverlay.js 2.2.1 (20110315) (20110314) Daniel,Frank $)";
	ap2FEE.log = function(str) {
		Application.console.log("ap2Fee: "+str);
	};
	
	if(ap2FEE.debug) { ap2FEE.log(ap2FEE.version); }
	
	ap2FEE.onload = function onload() {
		var dialog = document.getElementsByTagName("dialog")[0];
		if(ap2FEE.debug) { ap2FEE.log("onLoad()"); }
		dialog.setAttribute("ondialogaccept", "autoprint2FilterEditorExt.onAccept(); " + dialog.getAttribute("ondialogaccept"));
		//window.removeEventListener("load", autoprint2FilterEditorExt.init, true);
	};
	
	
	// this will get called when the user saves the filter
	// it tells autoprint if an where to a msg gets copied
	ap2FEE.onAccept = function() {
		var filterActionList = document.getElementById("filterActionList");
		var count = filterActionList.getRowCount();
		var apRow = null;
		var moveRow = null;
		
		if(ap2FEE.debug) { ap2FEE.log("onAccept(), "+count+" actions"); }
		
		// look after rois (rows of interest)
		for(var i=0;i<count;i++) {
			var actionRow = filterActionList.getItemAtIndex(i);
			switch(actionRow.getAttribute("value")) {
				case "movemessage": 
					moveRow = actionRow;
					break;
				case "autoprint2@daniel.luttinger.eu#print":
					apRow = actionRow;
				default:
			}	
		}
		
		// found the 2 rois, need to intervent
		if(apRow && moveRow) {			
			if(ap2FEE.debug) {ap2FEE.log("move and autoprint found"); }
			var target = document.getAnonymousNodes(moveRow)[1];
			var uri="";
			if(target) {
				uri=target.uri;
			}
				
			target = document.getAnonymousNodes(apRow)[1];
			if(target) {
					var item = document.getAnonymousNodes(target);
					if(item) {
						item[0].value=uri!=""?uri:"none";
					}
			}
		}
		
	};
	
	
})();

// a somewhat different way.. 'window.addEventListener' didn't work
window.onload = function(event){autoprint2FilterEditorExt.oldOnload(event);autoprint2FilterEditorExt.onload();};
